package com.njcn.device.pms.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.device.pms.api.PmsTerminalClient;
import com.njcn.device.pms.pojo.param.PmsBaseParam;
import com.njcn.device.pms.pojo.po.PmsTerminal;
import com.njcn.device.pms.utils.PmsDeviceEnumUtil;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author yzh
 * @date 2022/10/28
 */

@Slf4j
@Component
public class PmsTerminalClientFallbackFactory implements FallbackFactory<PmsTerminalClient> {
    @Override
    public PmsTerminalClient create(Throwable throwable) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (throwable.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) throwable.getCause();
            exceptionEnum = PmsDeviceEnumUtil.getExceptionEnum(businessException.getResult());
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new PmsTerminalClient() {
            @Override
            public  HttpResult<List<PmsTerminal>> getTerminalSelectList(PmsBaseParam pmsBaseParam) {
                log.error("{}异常，降级处理，异常为：{}", "获取主网所有终端", throwable.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<List<PmsTerminal>> getTerminalSelectByIds(List<String> ids) {
                log.error("{}异常，降级处理，异常为：{}", "使用装置id集合查询装置信息", throwable.toString());
                throw new BusinessException(finalExceptionEnum);
            }
        };
    }
}
